'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

exports.CyclopConnection = CyclopConnection;

var _isomorphicUnfetch = require('isomorphic-unfetch');

var _isomorphicUnfetch2 = _interopRequireDefault(_isomorphicUnfetch);

var _common = require('./common');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var fetchData = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(doc, url, customHeaders) {
    var data, defaultHeaders, headers, response;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            data = void 0;
            defaultHeaders = {
              'Content-Type': 'application/graphql'
            };
            headers = Object.assign(defaultHeaders, customHeaders);
            _context.prev = 3;
            _context.next = 6;
            return (0, _isomorphicUnfetch2.default)(url, {
              method: 'POST',
              headers: headers,
              body: doc
            });

          case 6:
            response = _context.sent;
            _context.next = 9;
            return response.json();

          case 9:
            data = _context.sent;
            _context.next = 15;
            break;

          case 12:
            _context.prev = 12;
            _context.t0 = _context['catch'](3);

            console.error(_context.t0);

          case 15:
            return _context.abrupt('return', data);

          case 16:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined, [[3, 12]]);
  }));

  return function fetchData(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

function CyclopConnection(network) {
  var url = network.url,
      headers = network.headers;

  this.url = url;
  this.headers = headers;
  this.query = function () {
    var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(doc) {
      var variables = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      var queryData, infoDoc;
      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              queryData = void 0;

              if (!(variables != null)) {
                _context2.next = 8;
                break;
              }

              infoDoc = (0, _common.mapDocWithVariables)(doc, variables);
              _context2.next = 5;
              return fetchData(infoDoc, this.url, this.headers);

            case 5:
              queryData = _context2.sent;
              _context2.next = 11;
              break;

            case 8:
              _context2.next = 10;
              return fetchData(doc, this.url, this.headers);

            case 10:
              queryData = _context2.sent;

            case 11:
              return _context2.abrupt('return', queryData);

            case 12:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    return function (_x4) {
      return _ref2.apply(this, arguments);
    };
  }(); // query
  this.mutate = function () {
    var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(doc) {
      var variables = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      var queryData, infoDoc;
      return _regenerator2.default.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              queryData = void 0;

              if (!(variables != null)) {
                _context3.next = 8;
                break;
              }

              infoDoc = (0, _common.mapDocWithVariables)(doc, variables);
              _context3.next = 5;
              return fetchData(infoDoc, this.url, this.headers);

            case 5:
              queryData = _context3.sent;
              _context3.next = 9;
              break;

            case 8:
              throw 'Not Found Variables';

            case 9:
              return _context3.abrupt('return', queryData);

            case 10:
            case 'end':
              return _context3.stop();
          }
        }
      }, _callee3, this);
    }));

    return function (_x6) {
      return _ref3.apply(this, arguments);
    };
  }(); // mutate
}